using System;
using System.Xml;
using System.Xml.XPath;
using System.Collections;
using System.Data.OleDb;
using System.Text;
using System.IO;

namespace NHFrog.Lib
{
	/// <summary>
	/// HbmXmlManage ժҪ˵
	/// </summary>
	public class HbmXmlManage
	{
	//	private string _hbmXmlFileName;
		private Hashtable _property;
		private XmlDocument _doc;
		private XmlElement _root;
		private XmlElement _firstNode;

		public HbmXmlManage(string pAssemlyFile,string pClassName,string pTableName)
		{
			//
			// TODO: ڴ˴ӹ캯߼
			//
			//Xmlļ
			this._doc = new XmlDocument();
			this._root = null;
			//
			this._property = new Hashtable();
			//
			this.ClassName = pClassName;
			this.AssemlyFile = pAssemlyFile;
			this.TableName = pTableName;
			this.generateDocument();
		}

		private string mAssemlyFile;

		/// <summary>
		/// áȡAssemlyFile
		/// </summary>
		public string AssemlyFile
		{
			get
			{
				return this.mAssemlyFile;
			}
			set
			{
				this.mAssemlyFile = value;
			}
		}
		private string mClassName;

		/// <summary>
		/// áȡClassName
		/// </summary>
		public string ClassName
		{
			get
			{
				return this.mClassName;
			}
			set
			{
				this.mClassName = value;
			}
		}

		private string mTableName;

		/// <summary>
		/// áȡTableName
		/// </summary>
		public string TableName
		{
			get
			{
				return this.mTableName;
			}
			set
			{
				this.mTableName = value;
			}
		}



		/// <summary>
		/// xmlļĳʼϢ(_doc_root)
		/// </summary>
		private void generateDocument()
		{		
			XmlDeclaration xmlDec = this._doc.CreateXmlDeclaration("1.0","utf-8", null);
			this._doc.AppendChild(xmlDec);
		
			XmlElement firCd = this._doc.CreateElement("hibernate-mapping");				
			firCd.SetAttribute("xmlns","urn:nhibernate-mapping-2.0");			

			this._doc.AppendChild(firCd);
			this._root = this._doc.DocumentElement;
		//	this._firstNode = firCd;

		}

		/// <summary>
		/// ֶΡӦִи÷ǰʼAssemblyNameTableName
		/// </summary>
		/// <param name="pIDProperty"></param>
		/// <param name="pAccess"></param>
		public void SetIDField(PropertyInfo pIDProperty,IDGeneratorKinds pAccess)
		{
			XmlElement newCd = this._doc.CreateElement("class");				
			newCd.SetAttribute("name",string.Format("{0}.{1},{0}",this.AssemlyFile,this.ClassName));
			newCd.SetAttribute("table",this.TableName);				

			XmlElement newID = this._doc.CreateElement("id");
			newID.SetAttribute("name",pIDProperty.PropertyName);
			if(pIDProperty.FieldName!="")
                newID.SetAttribute("column",pIDProperty.FieldName);
			newID.SetAttribute("type","Int32");

			XmlElement idNd = this._doc.CreateElement("generator");
			idNd.SetAttribute("class",pAccess.ToString());
			newID.AppendChild(idNd);

			newCd.AppendChild(newID);

			this._firstNode = newCd;
			this._root.AppendChild(newCd);

		}

		public void AddProperty(PropertyInfo pProperty)
		{
			this._property.Add(pProperty.PropertyName,pProperty);
		}

		public string GenerateCode()
		{
			StringWriter wr = new StringWriter();
			
		//	int i=0;
			IDictionaryEnumerator myEnumerator = this._property.GetEnumerator();			
			while ( myEnumerator.MoveNext() )
			{
				PropertyInfo info = (PropertyInfo)myEnumerator.Value;
				XmlElement proCd= this._doc.CreateElement("property");
				proCd.SetAttribute("name",info.PropertyName);
				if(info.FieldName!="")
                    proCd.SetAttribute("column",info.FieldName);
				proCd.SetAttribute("type",HbmXmlManage.GetHBType(info.DataType));
				if(info.Length>0)
                    proCd.SetAttribute("length",info.Length.ToString());

				this._firstNode.AppendChild(proCd);
			}
			this._doc.Save(wr);
			return wr.ToString();
		}

		public static string GetHBType(System.Data.OleDb.OleDbType pDbType)
		{
			switch(pDbType)
			{
				case OleDbType.Integer:					
					return "Int32";
				case OleDbType.WChar:
					return "string";
				case OleDbType.VarChar:
					return "string";
				case OleDbType.Currency:
					return "Decimal";
				case OleDbType.Boolean:
					return "Boolean";
				default:
					return "string";
			}
		}
	}
}
