using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace NHFrogGeneratorWizard
{
	/// <summary>
	/// DbSelectForm ժҪ˵
	/// </summary>
	public class DbSelectForm : System.Windows.Forms.Form
	{
		private Modules.DbSelectForm.DbType typeRoot;
	//	private Modules.DbSelectForm.DbConfig dbConfig;
		private Modules.DbStep curStep;
		private System.Windows.Forms.Panel plContent;
		private System.Windows.Forms.Button btnPre;
		private System.Windows.Forms.Button btnNext;
		private System.Windows.Forms.Button btnFinish;
		/// <summary>
		/// 
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DbSelectForm()
		{
			//
			// Windows ֧
			//
			InitializeComponent();

			//
			// TODO:  InitializeComponent úκι캯
			//			
			this.typeRoot = null;
		}

		/// <summary>
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void initStep()
		{
			this.typeRoot = new NHFrogGeneratorWizard.Modules.DbSelectForm.DbType();
			Modules.DbSelectForm.AccessLocator accLoc = new NHFrogGeneratorWizard.Modules.DbSelectForm.AccessLocator();
			Modules.DbSelectForm.SqlLocator sqlLoc = new NHFrogGeneratorWizard.Modules.DbSelectForm.SqlLocator();
		//	Modules.DbSelectForm.SqlDatabaseSelect typeSql = new NHFrogGeneratorWizard.Modules.DbSelectForm.SqlDatabaseSelect();
			Modules.DbSelectForm.SqlDatabaseSelect dataSel = new NHFrogGeneratorWizard.Modules.DbSelectForm.SqlDatabaseSelect();
			this.typeRoot.OnValueChanged+=new EventHandler(type_OnValueChanged);
			accLoc.OnValueChanged+=new EventHandler(type_OnValueChanged);
			sqlLoc.OnValueChanged+=new EventHandler(type_OnValueChanged);
			dataSel.OnValueChanged+=new EventHandler(type_OnValueChanged);

			this.typeRoot.AddDatabaseType("Access",accLoc);
			this.typeRoot.AddDatabaseType("SqlServer",sqlLoc);
			this.typeRoot.Dock = DockStyle.Fill;
			this.curStep = this.typeRoot;			
			this.plContent.Controls.Add(this.typeRoot);

            sqlLoc.StepNext = dataSel;
			dataSel.DbConfig = sqlLoc.DbConfig;
		//	this.dbConfig = sqlLoc.DbConfig;
		}

		#region Windows ɵĴ
		/// <summary>
		/// ֧ķ - Ҫʹô༭޸
		/// ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			this.plContent = new System.Windows.Forms.Panel();
			this.btnPre = new System.Windows.Forms.Button();
			this.btnNext = new System.Windows.Forms.Button();
			this.btnFinish = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// plContent
			// 
			this.plContent.Location = new System.Drawing.Point(0, 8);
			this.plContent.Name = "plContent";
			this.plContent.Size = new System.Drawing.Size(376, 208);
			this.plContent.TabIndex = 0;
			// 
			// btnPre
			// 
			this.btnPre.Location = new System.Drawing.Point(40, 232);
			this.btnPre.Name = "btnPre";
			this.btnPre.TabIndex = 1;
			this.btnPre.Text = "һ";
			this.btnPre.Click += new System.EventHandler(this.btnPre_Click);
			// 
			// btnNext
			// 
			this.btnNext.Location = new System.Drawing.Point(128, 232);
			this.btnNext.Name = "btnNext";
			this.btnNext.TabIndex = 2;
			this.btnNext.Text = "һ";
			this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
			// 
			// btnFinish
			// 
			this.btnFinish.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnFinish.Location = new System.Drawing.Point(288, 232);
			this.btnFinish.Name = "btnFinish";
			this.btnFinish.TabIndex = 3;
			this.btnFinish.Text = "";
			// 
			// DbSelectForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(376, 273);
			this.Controls.Add(this.btnFinish);
			this.Controls.Add(this.btnNext);
			this.Controls.Add(this.btnPre);
			this.Controls.Add(this.plContent);
			this.Name = "DbSelectForm";
			this.Text = "DbSelectForm";
			this.Load += new System.EventHandler(this.DbSelectForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void DbSelectForm_Load(object sender, System.EventArgs e)
		{
			this.initStep();
			this.refreshButtons();
		}

		private void refreshButtons()
		{
			this.btnPre.Enabled = this.curStep.CanPre();
			this.btnNext.Enabled = this.curStep.CanNext();
			this.btnFinish.Enabled =this.curStep.CanFinish();
		}

		private void type_OnValueChanged(object sender, EventArgs e)
		{
			this.refreshButtons();
		}

		private void btnPre_Click(object sender, System.EventArgs e)
		{
			this.curStep.PreStep(this.plContent);
			this.curStep = (Modules.DbStep)this.plContent.Controls[0];
			this.refreshButtons();
		}

		private void btnNext_Click(object sender, System.EventArgs e)
		{
			this.curStep.NextStep(this.plContent);
			this.curStep = (Modules.DbStep)this.plContent.Controls[0];
			this.refreshButtons();
		}

		public string ConnectString
		{
			get{return this.typeRoot.DbConfig.GetConnectString();}
		}
	}
}
