using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace NHFrogGeneratorWizard.Modules.DbSelectForm
{
	/// <summary>
	/// SqlDatabaseSelect ժҪ˵
	/// </summary>
	public class SqlDatabaseSelect : DbStep
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox cmbDatabase;
		/// <summary> 
		/// 
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SqlDatabaseSelect()
		{
			// õ Windows.Forms ġ
			InitializeComponent();

			// TODO:  InitializeComponent úκγʼ
			this.DbConfig = new SqlConfig();

		}

		/// <summary> 
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		


		#region ɵĴ
		/// <summary> 
		/// ֧ķ - Ҫʹô༭ 
		/// ޸Ĵ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.cmbDatabase = new System.Windows.Forms.ComboBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(32, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(112, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "ѡһݿ";
			// 
			// cmbDatabase
			// 
			this.cmbDatabase.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbDatabase.Location = new System.Drawing.Point(32, 56);
			this.cmbDatabase.Name = "cmbDatabase";
			this.cmbDatabase.Size = new System.Drawing.Size(121, 20);
			this.cmbDatabase.TabIndex = 1;
			this.cmbDatabase.SelectedIndexChanged += new System.EventHandler(this.cmbDatabase_SelectedIndexChanged);
			// 
			// SqlDatabaseSelect
			// 
			this.Controls.Add(this.cmbDatabase);
			this.Controls.Add(this.label1);
			this.Name = "SqlDatabaseSelect";
			this.Size = new System.Drawing.Size(256, 150);
			this.ResumeLayout(false);

		}
		#endregion

		public override void PreShowInPanel(StepEventArgs pArgs)
		{
			this.showAllDatabase();
			base.PreShowInPanel (pArgs);
		}

		public override bool CanFinish()
		{
			SqlConfig config = (SqlConfig)this.DbConfig;
			if(config.SelectDatabaseName !="")
				return true;
			else
				return false;
		}


		private void showAllDatabase()
		{
			this.cmbDatabase.Items.Clear();
			using(System.Data.OleDb.OleDbConnection con = new System.Data.OleDb.OleDbConnection(this.DbConfig.GetConnectString()))
			{
				
			//	string strSql = "sp_helpdb";
				string strSql = "SELECT sysdb.name AS name FROM sysdatabases AS sysdb";
				System.Data.OleDb.OleDbDataAdapter ada = new System.Data.OleDb.OleDbDataAdapter(strSql,con);
				DataTable table = new DataTable();
				try
				{
					ada.Fill(table);
					foreach(DataRow row in table.Rows)
					{
						string str = (string)row["name"];
						this.cmbDatabase.Items.Add(str);
					}
				}
				catch(Exception ee)
				{
					MessageBox.Show(ee.Message);
				}
				finally
				{
					con.Close();
				}
			}
				
		}

		private SqlConfig mSqlConfig;

		private void cmbDatabase_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			SqlConfig config = (SqlConfig)this.DbConfig;
			config.SelectDatabaseName = this.cmbDatabase.Text;
			this.RaiseValueChanged();
		}

//		/// <summary>
//		/// áȡDbConfig
//		/// </summary>
//		public DbConfig DbConfig
//		{
//			get
//			{
//				return this.mSqlConfig;
//			}
//			set
//			{
//				DbConfig config = value;
//				if(config is SqlConfig)
//                    this.mSqlConfig = value;
//				else
//					this.mSqlConfig = null;
//			}
//		}

		

	}
}
