using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace NHFrogGeneratorWizard.Modules.DbSelectForm
{
	/// <summary>
	/// SqlLocator ժҪ˵
	/// </summary>
	public class SqlLocator : DbStep
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.CheckBox chkTrue;
		private System.Windows.Forms.TextBox txtServer;
		private System.Windows.Forms.TextBox txtUser;
		private System.Windows.Forms.TextBox txtPassword;
		/// <summary> 
		/// 
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SqlLocator()
		{
			// õ Windows.Forms ġ
			InitializeComponent();

			// TODO:  InitializeComponent úκγʼ			
			
			this.DbConfig = new SqlConfig();
		}

		/// <summary> 
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region ɵĴ
		/// <summary> 
		/// ֧ķ - Ҫʹô༭ 
		/// ޸Ĵ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.chkTrue = new System.Windows.Forms.CheckBox();
			this.txtServer = new System.Windows.Forms.TextBox();
			this.txtUser = new System.Windows.Forms.TextBox();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(24, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(66, 17);
			this.label1.TabIndex = 0;
			this.label1.Text = "ַ";
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(24, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(42, 17);
			this.label2.TabIndex = 1;
			this.label2.Text = "û";
			// 
			// label3
			// 
			this.label3.AutoSize = true;
			this.label3.Location = new System.Drawing.Point(24, 80);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(29, 17);
			this.label3.TabIndex = 2;
			this.label3.Text = "";
			// 
			// chkTrue
			// 
			this.chkTrue.Location = new System.Drawing.Point(120, 104);
			this.chkTrue.Name = "chkTrue";
			this.chkTrue.TabIndex = 3;
			this.chkTrue.Text = "ʹ";
			this.chkTrue.CheckedChanged += new System.EventHandler(this.chkTrue_CheckedChanged);
			// 
			// txtServer
			// 
			this.txtServer.Location = new System.Drawing.Point(120, 16);
			this.txtServer.Name = "txtServer";
			this.txtServer.Size = new System.Drawing.Size(136, 21);
			this.txtServer.TabIndex = 4;
			this.txtServer.Text = ".";
			// 
			// txtUser
			// 
			this.txtUser.Location = new System.Drawing.Point(120, 40);
			this.txtUser.Name = "txtUser";
			this.txtUser.Size = new System.Drawing.Size(136, 21);
			this.txtUser.TabIndex = 5;
			this.txtUser.Text = "sa";
			// 
			// txtPassword
			// 
			this.txtPassword.Location = new System.Drawing.Point(120, 72);
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.PasswordChar = '*';
			this.txtPassword.Size = new System.Drawing.Size(136, 21);
			this.txtPassword.TabIndex = 6;
			this.txtPassword.Text = "";
			// 
			// SqlLocator
			// 
			this.Controls.Add(this.txtPassword);
			this.Controls.Add(this.txtUser);
			this.Controls.Add(this.txtServer);
			this.Controls.Add(this.chkTrue);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Name = "SqlLocator";
			this.Size = new System.Drawing.Size(312, 150);
			this.ResumeLayout(false);

		}
		#endregion


		private void chkTrue_CheckedChanged(object sender, System.EventArgs e)
		{
			this.txtPassword.Enabled = !this.chkTrue.Checked;
			this.txtUser.Enabled = !this.chkTrue.Checked;
		}

		public override void PreShowInPanel(StepEventArgs pArgs)
		{
			SqlConfig config = (SqlConfig)this.DbConfig;
			config.ServerName = this.txtServer.Text;
			config.UserName = this.txtUser.Text;
			config.Password = this.txtPassword.Text;
			config.IsByTrue = this.chkTrue.Checked;

			base.PreShowInPanel (pArgs);
		}


		
	}
}
