using System;
using System.Data;
using System.Data.OleDb;

namespace NHFrogGeneratorWizard
{
	/// <summary>
	/// Property ժҪ˵
	/// </summary>
	public class PropertyInfo
	{
		private string mFieldName;

		/// <summary>
		/// áȡFieldName
		/// </summary>
		public string FieldName
		{
			get
			{
				return this.mFieldName;
			}
			set
			{
				this.mFieldName = value;
			}
		}
		private string mPropertyName;

		/// <summary>
		/// áȡPropertyName
		/// </summary>
		public string PropertyName
		{
			get
			{
				return this.mPropertyName;
			}
			set
			{
				this.mPropertyName = value;
			}
		}
		private System.Data.OleDb.OleDbType mDataType;

		/// <summary>
		/// áȡDataType
		/// </summary>
		public System.Data.OleDb.OleDbType DataType
		{
			get
			{
				return this.mDataType;
			}
			set
			{
				this.mDataType = value;
			}
		}
		private int mLength;

		/// <summary>
		/// áȡLength
		/// </summary>
		public int Length
		{
			get
			{
				switch(this.DataType)
				{
					case OleDbType.Boolean:
						return -1;
					default:
						return this.mLength;
				}
			}
			set
			{				
				this.mLength = value;				
			}
		}


		/// <summary>
		/// 캯
		/// </summary>
		/// <param name="pPropertyName"></param>
		/// <param name="pFieldName"></param>
		/// <param name="pDbType"></param>
		/// <param name="pLength"></param>
		public PropertyInfo(string pPropertyName,string pFieldName,System.Data.OleDb.OleDbType pDbType,int pLength)
		{
			this.PropertyName = pPropertyName;
			this.FieldName = pFieldName;
			this.DataType = pDbType;
			this.Length = pLength;
		}

		/// <summary>
		/// 캯
		/// </summary>
		/// <param name="pPropertyName"></param>
		/// <param name="pFieldName"></param>
		/// <param name="pDbType"></param>
		public PropertyInfo(string pPropertyName,string pFieldName,System.Data.OleDb.OleDbType pDbType)
		{
			this.PropertyName = pPropertyName;
			this.FieldName = pFieldName;
			this.DataType = pDbType;
			this.Length = -1;
		}

		/// <summary>
		/// 캯
		/// </summary>
		/// <param name="pPropertyName"></param>
		/// <param name="pDbType"></param>
		public PropertyInfo(string pPropertyName,System.Data.OleDb.OleDbType pDbType)
		{
			this.PropertyName = pPropertyName;
			this.FieldName = "";
			this.DataType = pDbType;
			this.Length = -1;
		}

		public PropertyInfo(ColumnInfo pColumn)
		{
			this.PropertyName = pColumn.ColumnName;
			this.FieldName = pColumn.ColumnName;
			this.DataType = pColumn.DataType;
			this.Length = pColumn.MaxLength;
		}
	}
}
