using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;
using System.CodeDom;
using System.CodeDom.Compiler;
using EnvDTE;
using VSLangProj;


namespace NHFrogGeneratorWizard
{
	/// <summary>
	/// GeneratorForm ժҪ˵
	/// </summary>
	public class GeneratorForm : System.Windows.Forms.Form
	{
		private System.Data.OleDb.OleDbCommand oCom;
		private System.Data.OleDb.OleDbConnection oCon;
		private System.Data.DataView viewPrimaryKey;

		#region 
		private CodeDomProvider mCodeProvider;

		/// <summary>
		/// áȡCodeProvider
		/// </summary>
		public CodeDomProvider CodeProvider
		{
			get{return this.mCodeProvider;}
			set{this.mCodeProvider = value;}
		}

		private EnvDTE.DTE mApplicationObject;

		/// <summary>
		/// áȡApplicationObject
		/// </summary>
		public EnvDTE.DTE ApplicationObject
		{
			get{return this.mApplicationObject;}
			set
			{
				this.mApplicationObject = value;			
			}
		}

		private string mItemLocation;

		/// <summary>
		/// áȡItemLocation
		/// </summary>
		public string ItemLocation
		{
			get
			{
				return this.mItemLocation;
			}
			set
			{
				this.mItemLocation = value;
			}
		}
		private string mInstallDirectory;

		/// <summary>
		/// áȡInstallDirectory
		/// </summary>
		public string InstallDirectory
		{
			get
			{
				return this.mInstallDirectory;
			}
			set
			{
				this.mInstallDirectory = value;
			}
		}



		#endregion

		private System.Windows.Forms.TextBox txtFile;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.TreeView treeView1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.TextBox txtCode;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.TextBox txtXml;
		private System.Windows.Forms.Button btnBuild;
		private System.ComponentModel.IContainer components;

		public GeneratorForm()
		{
			//
			// Windows ֧
			//
			InitializeComponent();

			//
			// TODO:  InitializeComponent úκι캯
			//
			oCom=new OleDbCommand();
			oCon=new OleDbConnection();
			viewPrimaryKey = null;
			this.mApplicationObject = null;
		}
		

		/// <summary>
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows ɵĴ
		/// <summary>
		/// ֧ķ - Ҫʹô༭޸
		/// ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.txtFile = new System.Windows.Forms.TextBox();
			this.btnOK = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.btnBuild = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.txtXml = new System.Windows.Forms.TextBox();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.txtCode = new System.Windows.Forms.TextBox();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.treeView1 = new System.Windows.Forms.TreeView();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.groupBox1.SuspendLayout();
			this.panel1.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// txtFile
			// 
			this.txtFile.Location = new System.Drawing.Point(80, 24);
			this.txtFile.Name = "txtFile";
			this.txtFile.Size = new System.Drawing.Size(256, 21);
			this.txtFile.TabIndex = 0;
			this.txtFile.Text = "";
			// 
			// btnOK
			// 
			this.btnOK.Location = new System.Drawing.Point(360, 24);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(72, 23);
			this.btnOK.TabIndex = 1;
			this.btnOK.Text = "";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(8, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(66, 17);
			this.label1.TabIndex = 2;
			this.label1.Text = "ݿ";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.btnBuild);
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.txtFile);
			this.groupBox1.Controls.Add(this.btnOK);
			this.groupBox1.Dock = System.Windows.Forms.DockStyle.Top;
			this.groupBox1.Location = new System.Drawing.Point(0, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(704, 56);
			this.groupBox1.TabIndex = 3;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "ݿ";
			// 
			// btnBuild
			// 
			this.btnBuild.Location = new System.Drawing.Point(544, 24);
			this.btnBuild.Name = "btnBuild";
			this.btnBuild.Size = new System.Drawing.Size(72, 23);
			this.btnBuild.TabIndex = 4;
			this.btnBuild.Text = "ȷ";
			this.btnBuild.Click += new System.EventHandler(this.btnBuild_Click);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(456, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(72, 23);
			this.button1.TabIndex = 3;
			this.button1.Text = "Ԥ";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.groupBox3);
			this.panel1.Controls.Add(this.splitter2);
			this.panel1.Controls.Add(this.groupBox2);
			this.panel1.Controls.Add(this.splitter1);
			this.panel1.Controls.Add(this.treeView1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 56);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(704, 477);
			this.panel1.TabIndex = 4;
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.txtXml);
			this.groupBox3.Dock = System.Windows.Forms.DockStyle.Fill;
			this.groupBox3.Location = new System.Drawing.Point(155, 243);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(549, 234);
			this.groupBox3.TabIndex = 5;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "ļ(*.hmb.xml)";
			// 
			// txtXml
			// 
			this.txtXml.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtXml.Location = new System.Drawing.Point(3, 17);
			this.txtXml.Multiline = true;
			this.txtXml.Name = "txtXml";
			this.txtXml.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtXml.Size = new System.Drawing.Size(543, 214);
			this.txtXml.TabIndex = 0;
			this.txtXml.Text = "";
			// 
			// splitter2
			// 
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter2.Location = new System.Drawing.Point(155, 240);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(549, 3);
			this.splitter2.TabIndex = 4;
			this.splitter2.TabStop = false;
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.txtCode);
			this.groupBox2.Dock = System.Windows.Forms.DockStyle.Top;
			this.groupBox2.Location = new System.Drawing.Point(155, 0);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(549, 240);
			this.groupBox2.TabIndex = 3;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "(*.cs)";
			// 
			// txtCode
			// 
			this.txtCode.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtCode.Location = new System.Drawing.Point(3, 17);
			this.txtCode.Multiline = true;
			this.txtCode.Name = "txtCode";
			this.txtCode.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtCode.Size = new System.Drawing.Size(543, 220);
			this.txtCode.TabIndex = 2;
			this.txtCode.Text = "";
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(152, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 477);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// treeView1
			// 
			this.treeView1.CheckBoxes = true;
			this.treeView1.Dock = System.Windows.Forms.DockStyle.Left;
			this.treeView1.ImageIndex = -1;
			this.treeView1.Location = new System.Drawing.Point(0, 0);
			this.treeView1.Name = "treeView1";
			this.treeView1.SelectedImageIndex = -1;
			this.treeView1.Size = new System.Drawing.Size(152, 477);
			this.treeView1.TabIndex = 0;
			this.treeView1.AfterCheck += new System.Windows.Forms.TreeViewEventHandler(this.treeView1_AfterCheck);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// GeneratorForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(704, 533);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.groupBox1);
			this.Name = "GeneratorForm";
			this.Text = "NHFrog_power by kevin_Y";
			this.Load += new System.EventHandler(this.GeneratorForm_Load);
			this.groupBox1.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			//ӵĴ
//			MSDASC.DataLinksClass dl = new MSDASC.DataLinksClass();
//			ADODB.ConnectionClass conn = new ADODB.ConnectionClass();
//			object objConn = conn;
//			dl.PromptEdit(ref objConn);
			
			
			DbSelectForm frm = new DbSelectForm();
			if(frm.ShowDialog()==DialogResult.OK)
			{	
				this.txtFile.Text = frm.ConnectString;
				
				if(this.oCon.State == System.Data.ConnectionState.Open)
					this.oCon.Close();

				this.oCon.ConnectionString = frm.ConnectString;
				try
				{
					this.oCon.Open();
					this.listTable();
				}
				catch(Exception ee)
				{
					MessageBox.Show(ee.Message);
				}	
			}
						
		}

		

		

		private void listTable()
		{

			if(this.oCon.State != System.Data.ConnectionState.Open)
			{
				MessageBox.Show("ȴݿ");
				return;
			}

			DataTable dtTest=oCon.GetOleDbSchemaTable(OleDbSchemaGuid.Primary_Keys,null);
			this.viewPrimaryKey = dtTest.DefaultView;

			treeView1.Nodes.Clear();
			System.Windows.Forms.TreeNode nodeTable=treeView1.Nodes.Add("");
			//	oCon.Open();
			DataTable dtTables=oCon.GetOleDbSchemaTable(OleDbSchemaGuid.Tables,new object[]{null,null,null,"table"});
						
			if(dtTables!=null)
			{
						
				foreach(DataRow dtRow in dtTables.Rows)
				{
					string curNode=dtRow[2].ToString();
					System.Windows.Forms.TreeNode ndeP=nodeTable.Nodes.Add(curNode);
					ndeP.Tag = new TableInfo(curNode);
					//	ndeP.ImageIndex = -1;
					DataTable dtSubCol=oCon.GetOleDbSchemaTable(OleDbSchemaGuid.Columns,new Object[]{null,null,curNode});
					DataView colView = dtSubCol.DefaultView;
					colView.Sort = "ORDINAL_POSITION asc";//ԭ˳ʾĬϰĸ˳
					for(int i=0;i<colView.Count;i++)
					{
						DataRow curRow = colView[i].Row;						
						ColumnInfo col = this.getColumnObject(curRow);
						TreeNode nd = new TreeNode();					
						nd.Tag = col;
						nd.Text = col.ToString();
						ndeP.Nodes.Add(nd);
					}					
				}
			}
		}

		private ColumnInfo getColumnObject(DataRow pRow)
		{
			ColumnInfo col=new ColumnInfo(pRow["COLUMN_NAME"].ToString());
			col.DataType = (OleDbType)pRow["DATA_TYPE"];
			col.TableName = pRow["TABLE_NAME"].ToString();

			if (pRow["CHARACTER_MAXIMUM_LENGTH"]!=DBNull.Value)
				col.MaxLength = Convert.ToInt32(pRow["CHARACTER_MAXIMUM_LENGTH"]);

			col.AllowDBNull=(bool)pRow["IS_NULLABLE"];
			col.IsPrimaryKey = this.isPrimaryKey(col.TableName,col.ColumnName);
			return col;
		}
		private bool isPrimaryKey(string colTable,string colColumn)
		{
			viewPrimaryKey.RowFilter=string.Format("TABLE_NAME='{0}' and COLUMN_NAME='{1}'",colTable,colColumn);
			if(viewPrimaryKey.Count > 0)
				return true;
			else
				return false;
		}

		private string GetTypeName(object objType,int pLen)
		{
			string strReturn = "";
			System.Data.OleDb.OleDbType oleType = (System.Data.OleDb.OleDbType)objType;
			switch(oleType)
			{
				case OleDbType.WChar:
					strReturn = string.Format("WChar({0})",pLen);
					break;
				default:
					strReturn = oleType.ToString();
					break;
			}
			return strReturn;


		}

		private void treeView1_AfterCheck(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{

			foreach(TreeNode nd in e.Node.Nodes)
				nd.Checked = e.Node.Checked;
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//ȡĬϵռ
			string strDefaultNameSpace = "DefaultNameSpace";
			if(this.mApplicationObject!=null)
			{
				System.Array proList = (System.Array)this.mApplicationObject.ActiveSolutionProjects;
			
				if(proList.Length >0)
				{
					Project pro = (Project)proList.GetValue(0);
					strDefaultNameSpace = (string)pro.Properties.Item("RootNamespace").Value;
				}
			}
			//ȡ

			TreeNode node = this.treeView1.SelectedNode;
			if(node==null || node.Tag == null)
			{
				MessageBox.Show("ûѡе");
				return;
			}

			DbObject obj = (DbObject)node.Tag;
			if(obj.Hello() == "COLUMN")
				node = node.Parent;

			TableInfo obj2 = (TableInfo)node.Tag;
			CodeManage code = new CodeManage(strDefaultNameSpace,obj2.TableName);
			HbmXmlManage xml = new HbmXmlManage(strDefaultNameSpace,obj2.TableName,obj2.TableName);
			foreach(TreeNode nd in node.Nodes)
			{
				if(nd.Checked)
				{
					ColumnInfo cln = (ColumnInfo)nd.Tag;
					code.AddProperty(cln);
					PropertyInfo pro = new PropertyInfo(cln);
					if(cln.IsPrimaryKey)
						xml.SetIDField(pro,ColumnInfo.GetIDGeneratorKindsDescript(cln.DataType));	
					else
						xml.AddProperty(pro);
				}				
			}
            
			this.txtCode.Text = code.GenerateCode();
			this.txtXml.Text = xml.GenerateCode();
		}

		private void btnBuild_Click(object sender, System.EventArgs e)
		{
			//ȡĬϵռ
			string strDefaultNameSpace = "DefaultNameSpace";
			System.Array proList = (System.Array)this.mApplicationObject.ActiveSolutionProjects;
			
			if(proList.Length >0)
			{
				Project pro = (Project)proList.GetValue(0);
				strDefaultNameSpace = (string)pro.Properties.Item("RootNamespace").Value;
			}
			//ȡ


			TreeNode node = this.treeView1.SelectedNode;
			if(node==null || node.Tag == null)
			{
				MessageBox.Show("ûѡе");
				return;
			}

			DbObject obj = (DbObject)node.Tag;
			if(obj.Hello() == "COLUMN")
				node = node.Parent;

			TableInfo obj2 = (TableInfo)node.Tag;
			CodeManage code = new CodeManage(strDefaultNameSpace,obj2.TableName);
			HbmXmlManage xml = new HbmXmlManage(strDefaultNameSpace,code.ClassName,obj2.TableName);
			foreach(TreeNode nd in node.Nodes)
			{
				if(nd.Checked)
				{
					ColumnInfo cln = (ColumnInfo)nd.Tag;
					code.AddProperty(cln);
					PropertyInfo pro = new PropertyInfo(cln);
					if(cln.IsPrimaryKey)
						xml.SetIDField(pro,ColumnInfo.GetIDGeneratorKindsDescript(cln.DataType));	
					else
						xml.AddProperty(pro);
				}				
			}
            
			string strCode = code.GenerateCode();
			string newItemName = obj2.TableName + ".cs";
			string newItemCode = "";
			string newItemXml = "";
			switch(this.mApplicationObject.LocaleID)
			{
				case 2052:
					newItemCode = "\\ļ";
					newItemXml = "\\XML ļ";
					break;
				default:
					newItemCode = "Code\\Code File";
					newItemXml = "Data\\Xml File";
					break;
			}
			if(strCode!="")
			{
				this.mApplicationObject.ItemOperations.AddNewItem(newItemCode, newItemName);
				((TextDocument)this.mApplicationObject.ActiveDocument.Object("TextDocument")).StartPoint.CreateEditPoint().Insert(strCode);
			}
			strCode = xml.GenerateCode();
		//	newItemName = obj2.TableName + ".hbm.xml";
			newItemName = code.ClassName + ".hbm.xml";//hbm.xmlļӦʹƣhbm2dllʱ
			if(strCode!="")
			{
				//	ProjectItem item = this.mApplicationObject.ItemOperations.AddNewItem("\\XML ļ", newItemName);
				ProjectItem item = this.mApplicationObject.ItemOperations.AddNewItem(newItemXml, newItemName);
			//	item.Properties.Item("BuildAction").Value = prjBuildAction.prjBuildActionEmbeddedResource;
				item.Properties.Item("BuildAction").Value = 3;
				
			//	((TextDocument)this.mApplicationObject.ActiveDocument.Object("TextDocument")).StartPoint.CreateEditPoint().EndOfDocument();
				((TextDocument)this.mApplicationObject.ActiveDocument.Object("TextDocument")).EndPoint.CreateEditPoint().Insert(strCode);
			}
		}

		private void GeneratorForm_Load(object sender, System.EventArgs e)
		{
			this.txtFile.Text = this.InstallDirectory + "|" + this.ItemLocation;
		}
	}
}
