using System;

namespace NHFrogGeneratorWizard.Modules
{
	/// <summary>
	/// DbStep ժҪ˵
	/// </summary>
	public class DbStep:System.Windows.Forms.UserControl
	{
		/// <summary>
		/// ıǰ
		/// </summary>
		public event StepHandler PreStepChange;
		/// <summary>
		/// ı
		/// </summary>
		public event StepHandler OnStepChanged;
		/// <summary>
		/// Ҫʾǰ
		/// </summary>
		public event StepHandler OnPreShowInPanel;


		public event EventHandler OnValueChanging;

		public event EventHandler OnValueChanged;


		private DbConfig mDbConfig;

		/// <summary>
		/// áȡDbConfig
		/// </summary>
		public DbConfig DbConfig
		{
			get
			{
				return this.mDbConfig;
			}
			set
			{
				this.mDbConfig = value;
			}
		}

		private DbStep mPreStep;

		/// <summary>
		/// áȡ һһʱԶöԷһ
		/// </summary>
		public DbStep StepPre
		{
			get
			{
				return this.mPreStep;
			}
			set
			{
				
				this.mPreStep = value;
			}
		}
		private DbStep mNextStep;

		/// <summary>
		/// áȡһһʱͬʱöԷһΪԼ
		/// </summary>
		public DbStep StepNext
		{
			get
			{
				return this.mNextStep;
			}
			set
			{
				DbStep step = value;
				this.mNextStep = step;
				if(step!=null)
				{
					step.StepPre = this;
					this.DbConfig = step.DbConfig;//ָһõ
				}
			}
		}

		/// <summary>
		/// áȡCanPre
		/// </summary>
		public virtual bool CanPre()
		{
				if(this.StepPre == null)
					return false;
				else
					return true;
		}

		/// <summary>
		/// áȡCanNext
		/// </summary>
		public virtual bool CanNext()
		{
			if(this.StepNext == null)
				return false;
			else
				return true;
			
		}
	
		/// <summary>
		/// áȡCanFinlish
		/// </summary>
		public virtual bool CanFinish()
		{
			return false;
		}
		
		private string mTitle;

		/// <summary>
		/// áȡTitle
		/// </summary>
		public string Title
		{
			get
			{
				return (this.mTitle);
			}
			set
			{
				this.mTitle = value;
			}
		}

		public DbStep()
		{
			//
			// TODO: ڴ˴ӹ캯߼
			//
			this.StepNext = null;
			this.StepPre = null;		
		}

		public void RaiseValueChanged()
		{
			if(this.OnValueChanged!=null)
				this.OnValueChanged(this,new EventArgs());
		}

		public void RaiseValueChanging()
		{
			if(this.OnValueChanging!=null)
				this.OnValueChanging(this,new EventArgs());
		}

		/// <summary>
		/// Ҫʾ¼
		/// </summary>
		public virtual void PreShowInPanel(StepEventArgs pArgs)
		{
			if(this.OnPreShowInPanel != null)
				this.OnPreShowInPanel(this,pArgs);
		}

		/// <summary>
		/// һ
		/// </summary>
		/// <param name="pParnet"></param>
		public virtual void NextStep(System.Windows.Forms.Panel pParnet)
		{
//			if(this.StepNext == null)
//				return;
			StepEventArgs args = new StepEventArgs(1,false);
//			if(this.PreStepChange != null)
//				this.PreStepChange(this,args);
//
//			if(args.Cancel)
//				return;			

			this.PreShowInPanel(null);//ԼҪתһǰĳЩ

			this.StepNext.StepPre = this;			

			pParnet.Controls.Clear();
			pParnet.Controls.Add(this.StepNext);

			this.StepNext.PreShowInPanel(args);

			if(this.OnStepChanged != null)
				this.OnStepChanged(this,args);
		}

		/// <summary>
		/// һ
		/// </summary>
		/// <param name="pParnet"></param>
		public virtual void PreStep(System.Windows.Forms.Panel pParnet)
		{
//			if(this.StepPre == null)
//				return;
//
			StepEventArgs args = new StepEventArgs(-1,false);
//			if(this.PreStepChange != null)
//				this.PreStepChange(this,args);
//
//			if(args.Cancel)
//				return;			

			pParnet.Controls.Clear();
			pParnet.Controls.Add(this.StepPre);

			this.StepPre.PreShowInPanel(args);

			if(this.OnStepChanged != null)
				this.OnStepChanged(this,args);
		}
	}
}
